package com.zipcodewilmington;
import java.util.Arrays;

/**
 * Created by leon on 1/29/18.
 */
public class StringArrayUtils {
    /**
     * @param array array of String objects
     * @return first element of specified array
     */ // TODO
    public static String getFirstElement(String[] array) {
        return array[0];
    }

    /**
     * @param array array of String objects
     * @return second element in specified array
     */
    public static String getSecondElement(String[] array) {
        return array[1];
    }

    /**
     * @param array array of String objects
     * @return last element in specified array
     */ // TODO
    public static String getLastElement(String[] array) {
        return array[array.length - 1];
    }

    /**
     * @param array array of String objects
     * @return second to last element in specified array
     */ // TODO
    public static String getSecondToLastElement(String[] array) {
        return array[array.length - 2];
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return true if the array contains the specified `value`
     */ // TODO
    public static boolean contains(String[] array, String value) {

        boolean result = false;

        for (String s : array) {

            if (s.equals(value))
                result = true;

        }

        return result;
    }

    /**
     * @param array of String objects
     * @return an array with identical contents in reverse order
     */ // TODO
    public static String[] reverse(String[] array) {

        String[] result = new String[array.length];
        int j = 0;

        for (int i = (array.length - 1); i >= 0; i--) {

            result[j] = array[i];
            j++;

        }

        return result;
    }

    /**
     * @param array array of String objects
     * @return true if the order of the array is the same backwards and forwards
     */ // TODO
    public static boolean isPalindromic(String[] array) {

        return Arrays.equals(array, StringArrayUtils.reverse(array));
    }

    /**
     * @param array array of String objects
     * @return true if each letter in the alphabet has been used in the array
     */ // TODO
    public static boolean isPangramic(String[] array) {

        String alpha = "abcdefghijklmnopqrstuvwxyz";
        String original = Arrays.toString(array).toLowerCase();
        String newAlpha = "";

        for (int j = 0; j < alpha.length(); j++) {
            boolean found = false;

            for (int i = 0; i < original.length(); i++) {

                if(alpha.substring(j, (j+1)).equals(original.substring(i, i+1))) {
                    while (!found) {
                        newAlpha = newAlpha + alpha.substring(j, (j+1));
                        found = true;
                    }
                }

            }
        }

        boolean result = alpha.equals(newAlpha);

        return result;

    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return number of occurrences the specified `value` has occurred
     */ // TODO
    public static int getNumberOfOccurrences(String[] array, String value) {

        int result = 0;

        for (String s : array) {
            if (s.equals(value)) {
                result++;
            }
        }

        return result;
    }

    /**
     * @param array         array of String objects
     * @param valueToRemove value to remove from array
     * @return array with identical contents excluding values of `value`
     */ // TODO
    public static String[] removeValue(String[] array, String valueToRemove) {

        String[] result1 = new String[array.length];
        int i = 0;

        for (String s : array) {
            if(!s.equals(valueToRemove)) {
                result1[i] = s;
                i++;
            }
        }

        String[] result2 = Arrays.copyOf(result1, i);

        return result2;
    }

    /**
     * @param array array of chars
     * @return array of Strings with consecutive duplicates removes
     */ // TODO
    public static String[] removeConsecutiveDuplicates(String[] array) {

        String[] result1 = new String[array.length];
        String lastValue = "";
        int numb = 0;

        for (int i = 0; i < array.length; i++) {
            if (!array[i].equals(lastValue)) {
                lastValue = array[i];
                result1[numb] = array[i];
                numb++;
            }
        }

        String[] result2 = Arrays.copyOf(result1, numb);


        return result2;
    }

    /**
     * @param array array of chars
     * @return array of Strings with each consecutive duplicate occurrence concatenated as a single string in an array of Strings
     */ // TODO
    public static String[] packConsecutiveDuplicates(String[] array) {

        String[] result1 = new String[array.length];
        String lastValue = array[0];
        String running = array[0];
        int numb = 0;

        for (int i = 1; i < array.length; i++) {
            if (!array[i].equals(lastValue)) {
                lastValue = array[i];
                result1[numb] = running;
                running = array[i];
                numb++;
            } else {
                running = running + array[i];
            }
        }

        result1[numb] = running;

        String[] result2 = Arrays.copyOf(result1, numb+1);


        return result2;
    }


}
